Unit tde88e3_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UtRes_p, FATAN2M_p, DE88E_p;

function tde88e3: String;

implementation

function tde88e3: String;
var
M,IORDY,K0,IMAX,INIAPR,NXP1,NX,I,KP1,KP2,KP3,J,KD2,INCH :Integer;
YN,DYN,Y,DY,YT,DYT,DELY,DELDY,H0,H,XN,XK,R,W,P :Extended;
AYT :Array [0..12] of Extended;
DELAY :Array [0..12] of Extended;
XS :Array [0..1] of Extended;
AY :Array [0..12] of Extended;
ADY :Array [0..11] of Extended;
AD2Y :Array [0..10] of Extended;
RAB :Array [0..350] of Extended;
const
K :Integer = 10;
label
_31,_32,_34;
begin
Result := '';  {   }
{      PROGRAM TDEATA }
_BLOCKQ.elm1 := 0.0625e0;
M := 1;
XN := 0.e0;
YN := -ArcTan(_BLOCKQ.elm1);
DYN := 2.e0*_BLOCKQ.elm1/(1.e0+_BLOCKQ.elm1*_BLOCKQ.elm1);
IORDY := 2;
H0 := 1.e0;
XK := 1.e0;
YT := ArcTan(_BLOCKQ.elm1);
DYT := DYN;
K0 := K;
IMAX := 5;
INIAPR := 1;
H := H0;
DE88E(FATAN2M,M,XN,YN,DYN,XK,K0,INIAPR,IMAX,IORDY,H,Y,DY,NX,XS,AY,
     ADY,AD2Y,RAB);
DELY := YT -Y;
DELDY := DYT-DY;
NXP1 := NX+1;
Result := Result + Format(' NX=%4d ',[NX]) + #$0D#$0A;
Result := Result + Format('%s',['    XS=' + #$0D#$0A]);
for I:=1 to NXP1 do
 begin
  Result := Result + Format('%30.18e ',[XS[I-1]]) + #$0D#$0A;
 end;
Result := Result + #$0D#$0A;
Result := Result + Format(' H0=%20.16f    K=%3d    INIAPR=%1d    IMAX=%3d    IORDY=%2d ',
 [H,K,INIAPR,IMAX,IORDY]) + #$0D#$0A;
Result := Result + Format(' Y=  %30.18e'+#$0D#$0A+' YT= %30.18e'+#$0D#$0A+' DELTA Y  =%30.18e ',
 [Y,YT,DELY]) + #$0D#$0A;
Result := Result + Format(' DY= %30.18e'+#$0D#$0A+' DYT=%30.18e'+#$0D#$0A+' DELTA DY =%30.18e ',
 [DY,DYT,DELDY]) + #$0D#$0A;
{   .................................................... }
KP1 := K+1;
KP2 := K+2;
KP3 := K+3;
Result := Result + Format(#$0D#$0A+' COEFFICIENTS AY,ADY AND AD2Y ON %3d ',
 [NX]);
Result := Result + Format('%s',['  SEGMENT']) + #$0D#$0A;
Result := Result + Format('%s',
 ['   Number of                         Chebyshev coefficients' + #$0D#$0A +
 '              ------------------------------------------------------------------------' + #$0D#$0A +
 ' coefficient           for Y                  for Y''                    for Y''''' + #$0D#$0A +
 ' -------------------------------------------------------------------------------------' + #$0D#$0A]);
for J:=1 to KP1 do
 begin
  Result := Result + Format('  %2d  %30.18e %30.18e %30.18e ',[
J-1,AY[J-1],ADY[J-1],AD2Y[J-1]]) + #$0D#$0A;
 end;
Result := Result + Format('  %2d  %30.18e %30.18e'+#$0D#$0A+'  %2d  %30.18e ',
 [KP1,AY[KP2-1],ADY[KP2-1],KP2,AY[KP3-1]]) + #$0D#$0A;
{  __________________PRINT EXACT COEFFICIENTS AYT __________ }
P := (Sqrt(1.e0+_BLOCKQ.elm1*_BLOCKQ.elm1)-1.e0)/_BLOCKQ.elm1;
AYT[1] := 2.e0*P;
R := P*P;
W := 2.e0*P;
{ ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ }
KD2 := K div 2;
if ( ((K) Mod (2)) <> 0 ) 
 then KD2 := KD2+1;
{ ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ }
for I:=1 to KD2 do
 begin
  W := -W*R;
  AYT[2*I+1] := W/(2*I+1);
_31:
 end;
INCH := 1;
while ( INCH<=KP3 ) do
 begin
_32:
  AYT[INCH-1] := 0.e0;
  inc(INCH,2);
 end;
{      AY(1,1,1)=AY(1,1,1)*0.5e0 }
for I:=1 to KP3 do
 begin
_34:
  DELAY[I-1] := AYT[I-1]-AY[I-1];
 end;
DELAY[0] := AYT[0]-0.5e0*AY[0];
Result := Result + Format('%s',
 [#$0D#$0A'   Number of                   Chebyshev coefficients for Y ' + #$0D#$0A +
 '              ----------------------------------------------------------------------------' + #$0D#$0A +
 ' coefficient      approximate                  exact                absolute error' + #$0D#$0A +
 ' --------------------------------------------------------------------------------------' + #$0D#$0A]);
for J:=1 to KP3 do
 begin
  Result := Result + Format('  %2d  %30.18e %30.18e %30.18e ',[
J-1,AY[J-1],AYT[J-1],DELAY[J-1]]) + #$0D#$0A;
 end;
UtRes('tde88e3',Result);  {     tde88e3.res }
exit;
{  }
end;

end.
